---
title: Promise.allSettled()
slug: Web/JavaScript/Reference/Global_Objects/Promise/allSettled
tags:
  - JavaScript
  - Method
  - Promise
  - Reference
  - allSettled
  - asynchronous
---
<div>{{JSRef}}</div>

<p>The <code><strong>Promise.allSettled()</strong></code> method returns a promise that resolves after all of the given promises have either fulfilled or rejected, with an array of objects that each describes the outcome of each promise.</p>

<p>It is typically used when you have multiple asynchronous tasks that are not dependent on one another to complete successfully, or you'd always like to know the result of each promise.</p>

<p>In comparison, the Promise returned by {{jsxref("Promise.all()")}} may be more appropriate if the tasks are dependent on each other / if you'd like to immediately reject upon any of them rejecting.</p>

<div>{{EmbedInteractiveExample("pages/js/promise-allsettled.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>Promise</var>.allSettled(<var>iterable</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>iterable</var></code></dt>
 <dd>An <a href="/en-US/docs/Web/JavaScript/Guide/iterable">iterable</a> object, such as an {{jsxref("Array")}}, in which each member is a <code>Promise</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A <strong>pending</strong> {{jsxref("Promise")}} that will be <strong>asynchronously</strong> fulfilled once every promise in the specified collection of promises has completed, either by successfully being fulfilled or by being rejected. At that time, the returned promise's handler is passed as input an array containing the outcome of each promise in the original set of promises.</p>

<p>However, <strong>if and only if</strong> an empty iterable is passed as an argument, <code>Promise.allSettled()</code> returns a <code>Promise</code> object that has <strong>already been resolved</strong> as an empty array.</p>

<p>For each outcome object, a <code>status</code> string is present. If the status is <code>fulfilled</code>, then a <code>value</code> is present. If the status is <code>rejected</code>, then a <code>reason</code> is present. The value (or reason) reflects what value each promise was fulfilled (or rejected) with.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Promise.allSettled">Using Promise.allSettled</h3>

<pre class="brush: js notranslate">Promise.allSettled([
  Promise.resolve(33),
  new Promise(resolve =&gt; setTimeout(() =&gt; resolve(66), 0)),
  99,
  Promise.reject(new Error('an error'))
])
.then(values =&gt; console.log(values));

// [
//   {status: "fulfilled", value: 33},
//   {status: "fulfilled", value: 66},
//   {status: "fulfilled", value: 99},
//   {status: "rejected",  reason: Error: an error}
// ]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-promise.allsettled', 'Promise.allSettled')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">To contribute to this compatibility data, please write a pull request against this repository: <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a>.</div>

<p>{{Compat("javascript.builtins.Promise.allSettled")}}</p>

<h3 id="Implementation_Progress">Implementation Progress</h3>

<p>The following table provides a daily implementation status for this feature, because this feature has not yet reached cross-browser stability. The data is generated by running the relevant feature tests in <a href="https://github.com/tc39/test262">Test262</a>, the standard test suite of JavaScript, in the nightly build, or latest release of each browser's JavaScript engine.</p>

<div>{{EmbedTest262ReportResultsTable("Promise.allSettled")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Archive/Add-ons/Techniques/Promises">Promises</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Using_promises">Using promises</a></li>
 <li><a href="/en-US/docs/Learn/JavaScript/Asynchronous/Promises">Graceful asynchronous programming with promises</a></li>
 <li>{{jsxref("Promise")}}</li>
 <li>{{jsxref("Promise.all()")}}</li>
</ul>
